#include <fstream>

using namespace std;

ifstream fin("nave.in");
ofstream fout("nave.out");

struct baza
{
   int nr;
}M[105][105];

int n, m, b, xmax, ymax, nave_max;

void citire()
{
   int k, i, j, x;
   fin >> n >> m >> b;
   for (k = 1; k <= b; k++)
   {
      fin >> i >> j >> x;
      M[i][j].nr = x;
   }
   for (i = 0; i <= n + 1; i++)
      M[i][0].nr = M[i][m+1].nr = -1;
   for (j = 0; j <= m + 1; j++)
      M[0][j].nr = M[n+1][j].nr = -1;
}

int numara(int x, int y)
{
   int i, j, contor_nave = 0;
   i = x - 1; j = y - 1;        //stanga sus
   while (M[i][j].nr != -1)
   {
      if (M[i][j].nr != 0)
         contor_nave += M[i][j].nr;
      i--; j--;
   }
   i = x + 1; j = y - 1;        //stanga jos
   while (M[i][j].nr != -1)
   {
      if (M[i][j].nr != 0)
         contor_nave += M[i][j].nr;
      i++; j--;
   }
   i = x - 1; j = y + 1;        //dreapta sus
   while (M[i][j].nr != -1)
   {
      if (M[i][j].nr != 0)
         contor_nave += M[i][j].nr;
      i--; j++;
   }
   i = x + 1; j = y + 1;        //dreapta jos
   while (M[i][j].nr != -1)
   {
      if (M[i][j].nr != 0)
         contor_nave += M[i][j].nr;
      i++; j++;
   }
   return contor_nave;
}

void aterizare()
{
   int i, j, nave;
   for (i = 1; i <= n; i++)
      for (j = 1; j <= m; j++)
         if (M[i][j].nr == 0)
         {
            nave = numara(i, j);
            if (nave >= nave_max)
            {
               nave_max = nave;
               xmax = i; ymax = j;
            }
         }
}

void afisare()
{
   fout << nave_max << ' ' << xmax << ' ' << ymax << '\n';
}

int main()
{
   citire();
   aterizare();
   afisare();
   return 0;
}
