#include <fstream>
#include <cstring>
using namespace std;

ifstream fin("barlog.in");
ofstream fout("barlog.out");

int cerinta, n, m, starti, startj, D[101][101], result[] = {0, 1,-1};
int dl[] = { -1, 0, 1, 0 };
int dc[] = { 0, 1, 0, -1 };
struct element { int x, y; };
element Coada[10001], start;
char M[101][101][21], cartela[21];

void citire(); void bordare(); void rezolva(); int check_access(char camera[]);
int main()
{
	citire();
	bordare();
	rezolva();
	fout << result[cerinta]<<'\n';
	return 0;
}

void citire() {
	int i, j;
	fin >> cerinta;
	fin >> n;
	fin >> m;

	for (i = 1; i <= n; i++)
		for (j = 1; j <= m; j++)
			fin >> M[i][j];

	fin >> start.x;
	fin >> start.y;
	fin >> cartela;
}

void bordare() {
	int i, j;
	for (i = 1; i <= n+1; i++)
		D[i][0] = D[i][m + 1] = -1;
	for (j = 1; j <= m+1; j++)
		D[0][j] = D[n + 1][j] = -1;
}

int check_access(char camera[]) {
	int i;
	char *p = cartela;
	int lg_camera = strlen(camera);
	for (i = 0; i<lg_camera; i++)
	{
		p = strchr(p, camera[i]);
		if (p) p++;
		else return 0;
	}
	return 1;
}

void rezolva() {
	int prim = 0, ultim = 0;
	int i, j;
	element p;
	D[start.x][start.y] = 1;
	Coada[0] = start; prim = ultim = 0;

	while (prim <= ultim) {
		p = Coada[prim++];
		if (check_access(M[p.x][p.y]) == 1) {
			for (i = 0; i < 4; i++)
				if (D[p.x + dl[i]][p.y + dc[i]] == 0)
				{
					D[p.x + dl[i]][p.y + dc[i]] = D[p.x][p.y] + 1;
					result[1]++;
					++ultim;
					Coada[ultim].x = p.x + dl[i];
					Coada[ultim].y = p.y + dc[i];
				}
				else
					if (D[p.x + dl[i]][p.y + dc[i]] == -1 && result[2] == -1)
						result[2] = D[p.x][p.y];
		}
	}
}
